structure Generated =
struct

datatype 'a option = None | Some of 'a;

datatype 'a Tree = Tip | T of 'a Tree * 'a * 'a Tree;

fun tlookup h k Tip = None
  | tlookup h k (T (t1, x, t2)) =
    (if (k < h x) then tlookup h k t1
      else (if (h x < k) then tlookup h k t2 else Some x));

fun Let s f = f s;

fun split x = (fn p => x (fst p) (snd p));

fun wrmrm h (T (t1, x, t2)) =
    (if (t2 = Tip) then (t1, x)
      else (T (t1, x, fst (wrmrm h t2)), snd (wrmrm h t2)));

fun remove h e Tip = Tip
  | remove h e (T (t1, x, t2)) =
    (if (h e < h x) then T (remove h e t1, x, t2)
      else (if (h x < h e) then T (t1, x, remove h e t2)
             else (if (t1 = Tip) then t2
                    else Let (wrmrm h t1)
                           (split (fn t1p => fn r => T (t1p, r, t2))))));

fun binsert h e Tip = T (Tip, e, Tip)
  | binsert h e (T (t1, x, t2)) =
    (if (h e < h x) then T (binsert h e t1, x, t2)
      else (if (h x < h e) then T (t1, x, binsert h e t2) else T (t1, e, t2)));

fun id x = x;

val test = tlookup id 4 (remove id 3 (binsert id 4 (binsert id 3 Tip)));

end;

open Generated;
